% RA: Relación 02
% OTTER: puzle1.in
% Departamento de Ciencias de la Computación e Inteligencia Artificial
%==============================================================================


%==============================================================================
% Enunciado
%==============================================================================

% Un puzle está compuesto por las siguientes cuatro fichas:
%
%         +----+        +----+        +----+        +----+
%         |\  /|        |\  /|        |\  /|        |\  /|
%         |R\/V|        |V\/R|        |A\/V|        |R\/A|
%         |R/\V|        |V/\R|        |A/\V|        |R/\A|
%         |/  \|        |/  \|        |/  \|        |/  \|
%         +----+        +----+        +----+        +----+
%
% Donde R, V y A representan los colores Rojo, Verde y Azul, respectivamente.
%
% Utilizar OTTER para encontrar todas las maneras posibles de colocar estas
% cuatro fichas en línea, sin repetir, de forma lo colores de los lados
% adyacentes coincidan. Las fichas no se pueden girar.

%==============================================================================
% Formalización
%==============================================================================

% Configuración del sistema

% set(auto2).

set(hyper_res).
% set(para_from).
% set(para_into).
assign(max_proofs,-1).

% Lenguaje:
% ficha(x,y,z) - La ficha x tiene a la izquierda el color y, y a la derecha el
%                color z.
% posicion(x1,x2,x3,x4) - Las fichas x1, x2, x3, x4 se pueden colocar en línea
%                         de forma que los colores de los lados adyacentes
%                         coinciden.

formula_list(sos).
 all x (x = x).
 all x y (x = y -> y = x).
 all x y z (x = y & y = z -> x = z).

 1 != 2.
 1 != 3.
 1 != 4.
 2 != 3.
 2 != 4.
 3 != 4.

% Este ejercicio es una variante del presentado en el Tema 3, simplemente hay
% que añadir condiciones a la fórmula para exigir que las fichas sean
% distintas.

 all x1 x2 x3 x4 y1 y2 y3 y4 y5
  ((ficha(x1,y1,y2) & ficha(x2,y2,y3) &
    ficha(x3,y3,y4) & ficha(x4,y4,y5) &
    x1 != x2 & x1 != x3 & x1 != x4 &
    x2 != x3 & x2 != x4 & x3 != x4) -> posicion(x1,x2,x3,x4)).

 ficha(1,rojo,verde).
 ficha(2,verde,rojo).
 ficha(3,azul,verde).
 ficha(4,rojo,azul).
end_of_list.

formula_list(passive).
 all x1 x2 x3 x4 (posicion(x1,x2,x3,x4) -> $ANS(x1,x2,x3,x4)).
end_of_list.

%==============================================================================
